/*
 *  linux/include/asm-arm/arch-clps711x/irq.h
 *
 *  Copyright (C) 2000 Deep Blue Solutions Ltd.
 *  Copyright (C) 2001-2003 Atmark Techno, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef CONFIG_ARCH_ARMADILLO

#include <asm/arch/irqs.h>
#include <asm/arch/armadillo.h>

static inline int fixup_irq (unsigned int irq)
{
  if (irq == IRQ_EINT1) {
    int intsr;
    
    intsr = ((MISCREG_INTSR1 & 0x7) << 8) |
      ((MISCREG_INTSR2 & 0xf) << 4) | (MISCREG_INTSR3 & 0xf);
    if (!intsr) {
      return irq;
    }
    irq = IRQ_ISA_BASE;
    while (!(intsr & 1)) {
      irq++;
      intsr >>= 1;
    }
  }
  
  return irq;
}

#else

#define fixup_irq(i)	(i)

#endif
